//+------------------------------------------------------------------+
//|                        FiboPiv_3.mq4|
//|                                                                  |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
extern color Resistance_3 = Green;
extern color Resistance_2 = Green;
extern color Resistance_1 = Green;
extern color Piviot = Blue;
extern color Support_1 = Red;
extern color Support_2 = Red;
extern color Support_3 = Red;
extern int NBars = 300;
#property indicator_chart_window
string nn = "_12334879_";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   clean();
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

void clean(){
   for(int i=0; i<=ObjectsTotal(); i++){
     string n = ObjectName(i);
     if(StringFind(n, nn) != -1){
       ObjectDelete(n);
       i--;
     }
    }
}
    
double yesterday_close,yesterday_high,yesterday_low;
int bars = 1;

int start()
  {
      
  int counted = IndicatorCounted(), limit;
  if(counted < 0) return(0);
  limit = NBars - counted;

  if(TimeDay(Time[0]) != TimeDay(Time[1])){
    clean();
    limit = NBars;
  }
  int wday, ptime = -1;
  
  for(int a=0; a<=limit; a++){
    
    if(TimeDay(Time[a]) == TimeDay(Time[0])){
      ptime = Time[0];
      continue;
    }
    if(TimeDayOfWeek(Time[a]) == 0 || TimeDayOfWeek(Time[a]) == 6) continue;
    
    
    yesterday_low = Close[a]*2;
    yesterday_high = 0;
    yesterday_close = Close[a];
  
    int day = TimeDay(Time[a]);    
    while(/*true*/TimeDay(Time[a]) == day){       
      //if(TimeDay(Time[a]) != day){
      //  a--;
      //  break;
     // }
      if(Low[a] < yesterday_low) yesterday_low = Low[a];
      if(High[a] > yesterday_high) yesterday_high = High[a];
      day = TimeDay(Time[a]);        
      a++;
    } 
    a--;
    
    string time1 = TimeYear(ptime)+"."+TimeMonth(ptime)+"."+TimeDay(ptime)+" 00:00";
    string time2 = TimeYear(ptime)+"."+TimeMonth(ptime)+"."+TimeDay(ptime)+" 23:59";
    string time3 = TimeYear(ptime)+"."+TimeMonth(ptime)+"."+TimeDay(ptime)+" 4:00";
   
    draw("", time1+nn, StrToTime(time1), StrToTime(time2), StrToTime(time3));
   // Print("prev:"+TimeDay(Time[a+1])+"   calcDoneOn:"+TimeDay(Time[a])+"   display"+TimeDay(ptime));
     ptime = Time[a];
    //break; 
  }

//----
   return(0);
  }

void draw(string labName, string lineName, datetime time1, datetime time2, datetime time3){
  double R = yesterday_high - yesterday_low;//range
  double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
  double r3 = p + (R * 1.000);
  double r2 = p + (R * 0.618);
  double r1 = p + (R * 0.382);
  double s1 = p - (R * 0.382);
  double s2 = p - (R * 0.618);
  double s3 = p - (R * 1.000);

  drawLine(r3,"R3"+lineName, Resistance_3,1,time1,time2);
  drawLabel("Resistance 3",r3,Resistance_3,time3);
  drawLine(r2,"R2"+lineName, Resistance_2,2,time1,time2);
  drawLabel("Resistance 2",r2,Resistance_2,time3);
  drawLine(r1,"R1"+lineName, Resistance_1,0,time1,time2);
  drawLabel("Resistance 1"+labName,r1,Resistance_1,time3);

  drawLine(p,"PIVIOT"+lineName,Piviot,1,time1,time2);
  drawLabel("Piviot level",p,Piviot,time3);

  drawLine(s1,"S1"+lineName,Support_1,0,time1,time2);
  drawLabel("Support 1",s1,Support_1,time3);
  drawLine(s2,"S2"+lineName,Support_2,2,time1,time2);
  drawLabel("Support 2",s2,Support_2,time3);
  drawLine(s3,"S3"+lineName,Support_3,1,time1,time2);
  drawLabel("Support 3",s3,Support_3,time3);
}

void drawLabel(string name,double lvl,color Color, datetime time2)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name+nn, OBJ_TEXT, 0, time2, lvl);
        ObjectSetText(name+nn, name, 8, "Arial", EMPTY);
        ObjectSet(name+nn, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name+nn, 0, time2, lvl);
    }
}


void drawLine(double lvl,string name, color Col,int type, datetime time1, datetime time2)
{
//of "yyyy.mm.dd hh:mi" format.
  
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0,  time1, lvl, time2,lvl);
            ObjectSet(name, OBJPROP_RAY, 0);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0,  time1, lvl, time2,lvl);
            ObjectSet(name, OBJPROP_RAY, 0);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}